/*
  binforge - Repository system for Windows
  Copyright (C) 2009 Younes Serraj  Tous droits rservs.

  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la GNU General Public License telle que
  publie par la Free Software Foundation : soit la version 3 de cette
  licence, soit ( votre gr) toute version ultrieure.

  Ce programme est distribu dans lespoir quil vous sera utile, mais SANS
  AUCUNE GARANTIE : sans mme la garantie implicite de COMMERCIALISABILIT
  ni dADQUATION  UN OBJECTIF PARTICULIER. Consultez la Licence Gnrale
  Publique GNU pour plus de dtails.

  Vous devriez avoir reu une copie de la Licence Gnrale Publique GNU avec
  ce programme ; si ce nest pas le cas, consultez :
  <http://www.gnu.org/licenses/>.
*/

#ifdef BINFORGE_H
#ifndef STRINGOP_C
#define STRINGOP_C

#include <stdio.h>

char *substr(char *str, int begl, int length) {
	int i, j;
	char *result;
	
	result = (char*)malloc(sizeof(char)*length);
	
	for (i=begl, j=0; j<length && str[i]>=0; i++, j++)
		result[j] = str[i];
	
	result[j] = '\0';
	return (char*)result;
}

char *left(char *str, int length) {
	int i;
	char *result;
	
	result = (char*)malloc(sizeof(char)*(length+1));
	
	for (i=0; i<length && str[i]!='\0'; i++)
		result[i] = str[i];
	
	result[i] = '\0';
	return (char*) result;
}

char *right(char *str, int length) {
	int i, j;
	char *result;
	
	result = (char*)malloc(sizeof(char)*(length+1));
	
	for (i=strlen(str)-length, j=0; j<length && str[i]!='\0'; i++, j++)
		result[j] = str[i];
	
	result[j] = '\0';
	return (char*)result;
}

int substrcmp(char *str, char *substr, int location) {
	int i;
	
	if (location+strlen(substr)>strlen(str))
		return 1;
	
	for (i=0; i<strlen(substr); i++)
		if (str[location+i]!=substr[i])
			return 1;
	
	return 0;
}

int findchar(char *str, char c, int skip) {
	int length, location;
	
	length = strlen(str);

	for (location=0; location<length; location++) {
		if (str[location] == c) {
			if (skip > 0)
				skip--;
			else
				return location;
		}
	}
	
	return -1;
}

#endif STRINGOP_C
#endif BINFORGE_H
